using System;
using System.Collections.Generic;
using System.Text;

class Shopper
{
    public delegate void ToDo();
    public ToDo hook;

    public void GoShopping()
    {
        if (hook != null)
            hook();

        Console.WriteLine(" In eigener Sache shoppen");
    }
}


class CouchPotato
{
    private void GetBeer()
    {
        Console.WriteLine(" Bier einkaufen ");
    }

    public void OrderBeer(Shopper obj)
    {
        obj.hook = GetBeer;
    }

}


class Program
{
    static void Main(string[] args)
    {
        Shopper sh = new Shopper();
        CouchPotato cp = new CouchPotato();

        cp.OrderBeer(sh);

        sh.GoShopping();
    }
}

